/***************************************************************************/
/* J Drive (tm) Engine                                                     */
/* Copyright 2003-2005, Xilinx, Inc.                                       */
/* The use, reproduction, and distribution of this code is subject         */
/* to the J Drive license requirements and restrictions.                   */
/***************************************************************************/
// Parallel Port Driver Interface Functions
// For use with WinDrvr standard driver/vxd for WinNT/95
//
//==!========================================================================
//==! Defines to set development environment
//==!========================================================================
#define SYS_UNIX  0
//==!========================================================================
#ifndef BASJDRVIF_H
#define BASJDRVIF_H

#include <windows.h>
#include <winbase.h>
#include <stdio.h>

#if SYS_UNIX == 0
#define _CRTDBG_MAP_ALLOC
#include <stdlib.h>
#include <crtdbg.h>
#else
#include <stdlib.h>
#endif

#ifdef _MSC_VER
    #pragma warning( disable: 4201 )
#endif
#include <winioctl.h>
#ifdef _MSC_VER
    #pragma warning( default: 4201 )
#endif

#include "windrvr.h"


// Constants

//----------------------------------------------------------------------*/
// Base memory address containing the installed port IO addresses */
//----------------------------------------------------------------------*/

#define LPT_BASE_MEM_ADDR      0x0408;

//----------------------------------------------------------------------*/
// Only legal port IO address on PC98 machine  */
//----------------------------------------------------------------------*/

#define PC98_BASE_IO_ADDR  0x40;

//----------------------------------------------------------------------*/
// IO Port offsets from base for parallel port functions
//----------------------------------------------------------------------*/

#define DATA_OFFSET    (0*io_increment)
#define STATUS_OFFSET  (1*io_increment)
#define CONTROL_OFFSET (2*io_increment)

//----------------------------------------------------------------------*/
// Base driver class
//----------------------------------------------------------------------*/

class jdriver {
private:
  HANDLE hWD;
  DWORD io_increment;
  DWORD jcab_base_port;
  DWORD max_write_size;
  DWORD m_dwBufferSize;
  WD_TRANSFER *m_transfer;

public:
  
  jdriver();
  ~jdriver();
  int     open();
  void    close();

  int     GetParallelPorts( DWORD port_index );
  BOOLEAN WRTransfer( LPBYTE pOutBuf, LPBYTE pInBuf, DWORD dwSize );
  BYTE    ReadByte( DWORD dwIOAddr );
  BYTE    WriteByte( DWORD dwIOAddr, BYTE bData );

  DWORD   inline GetStatusPort() { return( jcab_base_port + STATUS_OFFSET ); }
  DWORD   inline GetDataPort() { return( jcab_base_port + DATA_OFFSET ); }
  DWORD   inline GetControlPort() { return( jcab_base_port + CONTROL_OFFSET ); }
  HANDLE  inline GetHWD() { return( hWD ); }
};

#endif



